All Libraries | This Library | Package | Class | Use | Tree | Deprecated | Index | Grand Index | Help
|  | Metadata |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.sas.metadata.remote
Interface SecurityRule

All Superinterfaces:
  CMetadata, MdObjectBase, MdObjectBaseUtil, MdObjectBaseXML, java.rmi.Remote, Root, SecondaryType

All Known Subinterfaces:
  SecurityTypeContainmentRule

    public interface SecurityRule

extends SecondaryType

This is an abstract class from which other "SecurityRules" will derive. Security rules are used to tell the authorization facility the rules it should use when making authorization decisions.

Attributes of SecurityRule are:

- `Rule`
- `Type`

Associations of SecurityRule are:

- `SecRuleScheme`

## Usage

To create an instance of this SecurityRule, use the `factory` create methods.
Example: create a SecurityRule with name "SecurityRule_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     SecurityRule myObject = (SecurityRule) factory.createComplexMetadataObject(objectStore, "SecurityRule_Object", MetadataObjects.SECURITYRULE, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

Field Summary
`static java.lang.String` | `ASSOCIATION_SECRULESCHEME_NAME` Constant used for the name of the SecRuleScheme association.
`static java.lang.String` | `ATTRIBUTE_RULE_NAME` Constant used for the name of the Rule attribute.
`static java.lang.String` | `ATTRIBUTE_TYPE_NAME` Constant used for the name of the Type attribute.

Fields inherited from interface com.sas.metadata.remote.Root
`ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

Fields inherited from interface com.sas.metadata.remote.MdObjectBase
`ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

Method Summary
`java.lang.String` | `getRule()` Gets the `String` value of `Rule`
`int` | `getRuleMaxLength()` Gets the maximum length of `Rule`
`int` | `getRuleState()` Gets the Metadata State of `Rule`
`SecurityRuleScheme` | `getSecRuleScheme()` Gets the `SecurityRuleScheme` for `SecRuleScheme`
`AssociationList` | `getSecRuleSchemes()` Gets the AssociationList of `SecRuleSchemes`
`AssociationList` | `getSecRuleSchemes(boolean fGoToServer)` Gets the Associationlist of `SecRuleSchemes`
`java.lang.String` | `getType()` Gets the `String` value of `Type`
`int` | `getTypeMaxLength()` Gets the maximum length of `Type`
`int` | `getTypeState()` Gets the Metadata State of `Type`
`void` | `initializePredObjects()` (S) Adds the Associated objects to the predObjects which are: `SecRuleScheme`
`void` | `initializeRequiredObjects()` (S) This initializes the Required Objects(Roles) which are: `SecRuleScheme`
`void` | `setRule(java.lang.String inRule)` Sets the `Rule` value and sets the state to MetadataState.LOCAL.
`void` | `setRule(java.lang.String inRule, int state)` Sets the `Rule` Metadata State.
`void` | `setRuleState(int state)` Sets the Metadata State of `Rule`.
`void` | `setSecRuleScheme(SecurityRuleScheme inObject)` Sets the `SecRuleSchemes` list 0th element to be `inObject`.
`void` | `setSecRuleSchemes(AssociationList list)` Sets the `SecRuleSchemes` list to be `list`.
`void` | `setSecRuleSchemes(AssociationList list, int state)` Sets the `SecRuleSchemes` list to be `list`.
`void` | `setType(java.lang.String inType)` Sets the `Type` value and sets the state to MetadataState.LOCAL.
`void` | `setType(java.lang.String inType, int state)` Sets the `Type` Metadata State.
`void` | `setTypeState(int state)` Sets the Metadata State of `Type`.

Methods inherited from interface com.sas.metadata.remote.Root
`getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML
`closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil
`addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

Methods inherited from interface com.sas.metadata.remote.MdObjectBase
`addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

Field Detail

### ATTRIBUTE_RULE_NAME

    static final java.lang.String ATTRIBUTE_RULE_NAME

  Constant used for the name of the Rule attribute.

  Rule: Rule

  See Also:
    Constant Field Values

### ATTRIBUTE_TYPE_NAME

    static final java.lang.String ATTRIBUTE_TYPE_NAME

  Constant used for the name of the Type attribute.

  Type: Used to indicate the category of the particular rule.

  See Also:
    Constant Field Values

### ASSOCIATION_SECRULESCHEME_NAME

    static final java.lang.String ASSOCIATION_SECRULESCHEME_NAME

  Constant used for the name of the SecRuleScheme association.

  SecRuleScheme: The security rule scheme that contains this rule.

  See Also:
    Constant Field Values

Method Detail

### initializeRequiredObjects

    void initializeRequiredObjects()
                                   throws java.rmi.RemoteException

  (S) This initializes the Required Objects(Roles) which are:
  `SecRuleScheme`

  Specified by:
    `initializeRequiredObjects` in interface `MdObjectBaseUtil`
  Specified by:
    `initializeRequiredObjects` in interface `Root`
  Specified by:
    `initializeRequiredObjects` in interface `SecondaryType`
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### initializePredObjects

    void initializePredObjects()
                               throws java.rmi.RemoteException

  (S) Adds the Associated objects to the predObjects which are:
  `SecRuleScheme`

  Specified by:
    `initializePredObjects` in interface `MdObjectBase`
  Specified by:
    `initializePredObjects` in interface `Root`
  Specified by:
    `initializePredObjects` in interface `SecondaryType`
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### getRule

    java.lang.String getRule()
                             throws java.rmi.RemoteException

  Gets the `String` value of `Rule`

  Returns:
    The `Rule`
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### getRuleState

    int getRuleState()
                     throws java.rmi.RemoteException

  Gets the Metadata State of `Rule`

  Returns:
    The State.
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### getRuleMaxLength

    int getRuleMaxLength()
                         throws java.rmi.RemoteException

  Gets the maximum length of `Rule`

  Returns:
    The max size
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### getType

    java.lang.String getType()
                             throws java.rmi.RemoteException

  Gets the `String` value of `Type`

  Returns:
    The `Type`
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### getTypeState

    int getTypeState()
                     throws java.rmi.RemoteException

  Gets the Metadata State of `Type`

  Returns:
    The State.
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### getTypeMaxLength

    int getTypeMaxLength()
                         throws java.rmi.RemoteException

  Gets the maximum length of `Type`

  Returns:
    The max size
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### getSecRuleSchemes

    AssociationList getSecRuleSchemes()
                                      throws java.rmi.RemoteException,
                                             MdException

  Gets the AssociationList of `SecRuleSchemes`

  Returns:
    Returns the AssociationList of `SecRuleSchemes` which can be of type:
    SecurityRuleScheme
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.
    `MdException`

### getSecRuleScheme

    SecurityRuleScheme getSecRuleScheme()
                                        throws java.rmi.RemoteException,
                                               MdException

  Gets the `SecurityRuleScheme` for `SecRuleScheme`

  Returns:
    The `SecurityRuleScheme` ( `null` if not set) of `SecRuleScheme`which can be of type:
    SecurityRuleScheme
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.
    `MdException` - If error getting/setting part of the object.

### getSecRuleSchemes

    AssociationList getSecRuleSchemes(boolean fGoToServer)
                                      throws java.rmi.RemoteException,
                                             MdException

  Gets the Associationlist of `SecRuleSchemes`

  Parameters:
    `fGoToServer` - boolean Get the value from the server.
  Returns:
    Returns the AssociationList of `SecRuleSchemes` which can be of type:
    SecurityRuleScheme
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.
    `MdException` - If error getting/setting part of the object.

### setRule

    void setRule(java.lang.String inRule)
                 throws java.rmi.RemoteException

  Sets the `Rule` value and sets the state to MetadataState.LOCAL.

  Parameters:
    `inRule` - String
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setRule

    void setRule(java.lang.String inRule,
                 int state)
                 throws java.rmi.RemoteException

  Sets the `Rule` Metadata State.

  Parameters:
    `inRule` - String
    `state` - int
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setRuleState

    void setRuleState(int state)
                      throws java.rmi.RemoteException

  Sets the Metadata State of `Rule`.

  Parameters:
    `state` - int
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setType

    void setType(java.lang.String inType)
                 throws java.rmi.RemoteException

  Sets the `Type` value and sets the state to MetadataState.LOCAL.

  Parameters:
    `inType` - String
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setType

    void setType(java.lang.String inType,
                 int state)
                 throws java.rmi.RemoteException

  Sets the `Type` Metadata State.

  Parameters:
    `inType` - String
    `state` - int
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setTypeState

    void setTypeState(int state)
                      throws java.rmi.RemoteException

  Sets the Metadata State of `Type`.

  Parameters:
    `state` - int
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setSecRuleSchemes

    void setSecRuleSchemes(AssociationList list)
                           throws java.rmi.RemoteException

  Sets the `SecRuleSchemes` list to be `list`. Object of which can be of type:
  SecurityRuleScheme

  Parameters:
    `list` - AssociationList
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setSecRuleSchemes

    void setSecRuleSchemes(AssociationList list,
                           int state)
                           throws java.rmi.RemoteException

  Sets the `SecRuleSchemes` list to be `list`. Object of which can be of type:
  SecurityRuleScheme

  Parameters:
    `list` - AssociationList
    `state` - int
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setSecRuleScheme

    void setSecRuleScheme(SecurityRuleScheme inObject)
                          throws java.rmi.RemoteException

  Sets the `SecRuleSchemes` list 0th element to be `inObject`.

  Parameters:
    `inObject` - SecurityRuleScheme
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

All Libraries | This Library | Package | Class | Use | Tree | Deprecated | Index | Grand Index | Help
|  | Metadata |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2009 SAS Institute Inc. All Rights Reserved.